
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Graphe &#8212; Documentation Segmentation Image 2.0</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Recherche" href="../search.html" /> 
  </head><body>
<div style="background-color: white; text-align: left; padding: 10px 10px 15px 15px">
  <a href="../index.html">
  <img src="../_static/logo.png" border="0" alt="Segmentation Image"/>
  </a>
</div>

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Code du module</a> &#187;</li> 
      </ul>
    </div>

      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Recherche rapide</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Code source de Graphe</h1><div class="highlight"><pre>
<span></span><span class="c1">#####################################</span>
<span class="c1"># Cecile Prouteau</span>
<span class="c1"># CTES Projet Math-Info</span>
<span class="c1"># Projet segmentation d&#39;image</span>
<span class="c1"># 15/01/2019</span>
<span class="c1"># Classe Graphe Version 0.1</span>
<span class="c1">#####################################</span>

<span class="c1">### IMPORTATION DES BIBLIOTHEQUES</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">math</span>

<span class="c1">### IMPORTATION DES CLASSES</span>
<span class="kn">from</span> <span class="nn">Image</span> <span class="k">import</span> <span class="n">Image</span>
<span class="kn">from</span> <span class="nn">Sommet</span> <span class="k">import</span> <span class="n">Sommet</span>
<span class="kn">from</span> <span class="nn">Arc</span> <span class="k">import</span> <span class="n">Arc</span>


<span class="c1">### DEBUT de la classe Graphe</span>

<div class="viewcode-block" id="Graphe"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe">[docs]</a><span class="k">class</span> <span class="nc">Graphe</span><span class="p">:</span>
<div class="viewcode-block" id="Graphe.__init__"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">image</span><span class="p">,</span><span class="n">source</span><span class="p">,</span><span class="n">puits</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;image est un tableau numpy d&#39;une image codée sur une couche en niveaux de gris</span>
<span class="sd">        source et puits sont des sommets particulier du graphe&quot;&quot;&quot;</span>
        
        <span class="c1">#self.image=image.image_np_gray</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">largeur</span> <span class="o">=</span> <span class="n">image</span><span class="o">.</span><span class="n">largeur</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span> <span class="o">=</span> <span class="n">image</span><span class="o">.</span><span class="n">hauteur</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span>
        
        <span class="nb">print</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="p">)</span>
        
        <span class="c1"># gestion de la source et du puits</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">source</span> <span class="o">=</span> <span class="n">source</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">no_source</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">coordonnees_2_no_sommet</span><span class="p">(</span><span class="n">source</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="n">source</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
        <span class="c1"># NS=self.no_source</span>
        <span class="c1"># print(&quot;source = %d&quot;%NS)</span>
        <span class="c1"># source.affiche_sommet()</span>
        <span class="c1"># print(self.no_sommet_2_coordonnees(NS))</span>
        <span class="c1"># print()</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">puits</span> <span class="o">=</span> <span class="n">puits</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">no_puits</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">coordonnees_2_no_sommet</span><span class="p">(</span><span class="n">puits</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="n">puits</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
        <span class="c1"># NP=self.no_puits</span>
        <span class="c1"># print(&quot;puits = %d&quot;%NP)</span>
        <span class="c1"># puits.affiche_sommet()</span>
        <span class="c1"># print(self.no_sommet_2_coordonnees(NP))</span>
        <span class="c1"># print()</span>
        
        <span class="c1">#La liste des sommets du graphe</span>
        <span class="c1">#self.liste_sommets = </span>
        <span class="bp">self</span><span class="o">.</span><span class="n">image_2_liste_sommets</span><span class="p">(</span><span class="n">image</span><span class="p">)</span>
        <span class="c1">#print(len(self.liste_sommets))</span>
        <span class="c1"># for s in self.liste_sommets:</span>
        <span class="c1">#     s.affiche_sommet()</span>
        <span class="c1"># print()</span>
        
        <span class="c1">#La liste des listes des arcs partant de chaque sommet graphe</span>
        <span class="c1">#self.liste_arcs = </span>
        <span class="bp">self</span><span class="o">.</span><span class="n">image_2_liste_arcs</span><span class="p">(</span><span class="n">image</span><span class="p">)</span></div>
        <span class="c1">#print(self.liste_arcs)</span>
        <span class="c1">#print(len(self.liste_arcs))</span>
        <span class="c1"># for l in self.liste_arcs:</span>
        <span class="c1">#     for a in l:</span>
        <span class="c1">#         a.affiche_arc()</span>
        <span class="c1">#     print()</span>
        
    <span class="c1">## FONCTIONS SUR LES SOMMETS    </span>
<div class="viewcode-block" id="Graphe.coordonnees_2_no_sommet"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.coordonnees_2_no_sommet">[docs]</a>    <span class="k">def</span> <span class="nf">coordonnees_2_no_sommet</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Retourne l&#39;indice du sommet dans la liste à partir de ses coordonnées de point sur l&#39;image&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">x</span><span class="o">+</span><span class="n">y</span><span class="o">*</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="Graphe.sommet_2_no_sommet"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.sommet_2_no_sommet">[docs]</a>    <span class="k">def</span> <span class="nf">sommet_2_no_sommet</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">sommet</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Retourne l&#39;indice du sommet dans la liste à partir du sommet&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">coordonnees_2_no_sommet</span><span class="p">(</span><span class="n">sommet</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="n">sommet</span><span class="o">.</span><span class="n">y</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="Graphe.no_sommet_2_coordonnees"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.no_sommet_2_coordonnees">[docs]</a>    <span class="k">def</span> <span class="nf">no_sommet_2_coordonnees</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">n</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Retourne les coordonnées du sommet sur l&#39;image à partir de son numéro dans la liste&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">n</span><span class="o">%</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">,</span><span class="n">n</span><span class="o">//</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="Graphe.ajoute_sommet"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.ajoute_sommet">[docs]</a>    <span class="k">def</span> <span class="nf">ajoute_sommet</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Ajoute le sommet de coordonnées (x,y) sur l&#39;image à liste&quot;&quot;&quot;</span>
        <span class="n">sommet</span><span class="o">=</span><span class="n">Sommet</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">liste_sommets</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">sommet</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="Graphe.image_2_liste_sommets"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.image_2_liste_sommets">[docs]</a>    <span class="k">def</span> <span class="nf">image_2_liste_sommets</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">img</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Crée la liste des sommets à partir de l&#39;image parcourue colonne par colonne - le tableau numpy est parcouru ligne par ligne à cause de l&#39;inversion des coordonnées )&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">liste_sommets</span><span class="o">=</span><span class="p">[]</span>
        <span class="k">for</span> <span class="n">y</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span><span class="p">):</span>
            <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">range</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">):</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">ajoute_sommet</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">)</span></div>
                
<div class="viewcode-block" id="Graphe.liste_no_sommets_voisins"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.liste_no_sommets_voisins">[docs]</a>    <span class="k">def</span> <span class="nf">liste_no_sommets_voisins</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; détermine la liste des numéros de sommets voisins d&#39;un sommet identifié par son numéro</span>
<span class="sd">        est utilisée pour la création de la liste des arcs donc ne peut pas se servir de celle-ci&quot;&quot;&quot;</span>
        <span class="n">Liste_no_voisins</span><span class="o">=</span><span class="p">[]</span>
        <span class="n">sommet</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">liste_sommets</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">sommet</span><span class="o">.</span><span class="n">x</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">voisin_gauche</span><span class="o">=</span><span class="n">sommet</span><span class="o">.</span><span class="n">voisin</span><span class="p">(</span><span class="s1">&#39;gauche&#39;</span><span class="p">)</span>
            <span class="n">Liste_no_voisins</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">voisin_gauche</span><span class="p">))</span>
        <span class="k">if</span> <span class="n">sommet</span><span class="o">.</span><span class="n">x</span> <span class="o">&lt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="o">-</span><span class="mi">1</span> <span class="p">:</span>
            <span class="n">voisin_droit</span><span class="o">=</span><span class="n">sommet</span><span class="o">.</span><span class="n">voisin</span><span class="p">(</span><span class="s1">&#39;droite&#39;</span><span class="p">)</span>
            <span class="n">Liste_no_voisins</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">voisin_droit</span><span class="p">))</span>
        <span class="k">if</span> <span class="n">sommet</span><span class="o">.</span><span class="n">y</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">voisin_haut</span><span class="o">=</span><span class="n">sommet</span><span class="o">.</span><span class="n">voisin</span><span class="p">(</span><span class="s1">&#39;haut&#39;</span><span class="p">)</span>
            <span class="n">Liste_no_voisins</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">voisin_haut</span><span class="p">))</span>
        <span class="k">if</span> <span class="n">sommet</span><span class="o">.</span><span class="n">y</span> <span class="o">&lt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span><span class="o">-</span><span class="mi">1</span> <span class="p">:</span>
            <span class="n">voisin_bas</span><span class="o">=</span><span class="n">sommet</span><span class="o">.</span><span class="n">voisin</span><span class="p">(</span><span class="s1">&#39;bas&#39;</span><span class="p">)</span>
            <span class="n">Liste_no_voisins</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">voisin_bas</span><span class="p">))</span>
            
        <span class="c1"># si liste des arcs connue la fonction pourrait être</span>
        <span class="c1"># for a in self.liste_arcs:</span>
        <span class="c1">#     Liste_voisins.append(self.coordonnees_2_no_sommet(a.destination.x,a.destination.y))</span>
        <span class="c1">#print(Liste_no_voisins)</span>
        <span class="k">return</span> <span class="n">Liste_no_voisins</span></div>

    <span class="c1">## FONCTIONS SUR LES ARCS</span>

<div class="viewcode-block" id="Graphe.cree_arc"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.cree_arc">[docs]</a>    <span class="k">def</span> <span class="nf">cree_arc</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">origine</span><span class="p">,</span><span class="n">destination</span><span class="p">,</span><span class="n">img</span><span class="p">):</span> 
        <span class="sd">&quot;&quot;&quot; Crée un arc allant du sommet origine au sommet destination. son poids est déterminé comme valeur absolue de la différence entre les couleurs des pixels correspondants sur l&#39;image img codées sur 8 bits en niveaux de gris&quot;&quot;&quot;</span>
        <span class="n">poids</span> <span class="o">=</span> <span class="nb">abs</span><span class="p">(</span><span class="n">img</span><span class="o">.</span><span class="n">couleur_entier_8bits</span><span class="p">(</span><span class="n">destination</span><span class="o">.</span><span class="n">y</span><span class="p">,</span><span class="n">destination</span><span class="o">.</span><span class="n">x</span><span class="p">)</span> <span class="o">-</span> <span class="n">img</span><span class="o">.</span><span class="n">couleur_entier_8bits</span><span class="p">(</span><span class="n">origine</span><span class="o">.</span><span class="n">y</span><span class="p">,</span><span class="n">origine</span><span class="o">.</span><span class="n">x</span><span class="p">))</span>
        <span class="k">return</span> <span class="n">Arc</span><span class="p">(</span><span class="n">origine</span><span class="p">,</span><span class="n">destination</span><span class="p">,</span><span class="n">poids</span><span class="p">)</span></div>
    
    <span class="c1"># def cree_double_arc(self,sommet_1,sommet_2):</span>
    <span class="c1">#     &quot;&quot;&quot;Crée les arcs dans les deux sens entre le sommet 2 et le sommet 2&quot;&quot;&quot;</span>
    <span class="c1">#     self.cree_arc(sommet_1,sommet_2)</span>
    <span class="c1">#     self.cree_arc(sommet_2,sommet_1)</span>
        
<div class="viewcode-block" id="Graphe.ajoute_arc"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.ajoute_arc">[docs]</a>    <span class="k">def</span> <span class="nf">ajoute_arc</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">origine</span><span class="p">,</span><span class="n">destination</span><span class="p">,</span><span class="n">img</span><span class="p">):</span> <span class="c1">#??? </span>
        <span class="sd">&quot;&quot;&quot; Ajoute l&#39;arc allant du sommet origine au sommet destination. son poids est déterminé comme valeur absolue de la différence entre les couleurs des pixels correspondants sur l&#39;image img codées sur 8 bits en niveaux de gris à la liste des arcs issus du sommet origine&quot;&quot;&quot;</span>
        <span class="n">arc</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">cree_arc</span><span class="p">(</span><span class="n">origine</span><span class="p">,</span><span class="n">destination</span><span class="p">,</span><span class="n">img</span><span class="p">)</span>
        <span class="n">no_sommet</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">coordonnees_2_no_sommet</span><span class="p">(</span><span class="n">origine</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="n">origine</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">arc</span><span class="p">)</span></div>
        
    <span class="k">def</span> <span class="nf">supprime_arc</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">arc</span><span class="p">):</span>
        <span class="n">no_origine</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">coordonnees_2_no_sommet</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">origine</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="n">arc</span><span class="o">.</span><span class="n">origine</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_origine</span><span class="p">]:</span>
            <span class="k">if</span> <span class="n">arc</span><span class="o">.</span><span class="n">destination</span> <span class="o">==</span> <span class="n">a</span><span class="o">.</span><span class="n">destination</span> <span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_origine</span><span class="p">]</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">a</span><span class="p">)</span>
    
    <span class="c1"># def cree_arcs_de_sommet_vers_voisins(self , no_sommet, img):</span>
    <span class="c1">#     &quot;&quot;&quot; Crée tous les arc partant d&#39;un sommet identifié par son no vers tous ses voisins</span>
    <span class="c1">#     si le sommet n&#39;est pas le puits, chercher les voisins et creer les arcs qui vont su sommet vers ses voisins&quot;&quot;&quot;</span>
    <span class="c1">#     sommet=self.liste_sommets[no_sommet]</span>
    <span class="c1">#     if no_sommet != self.no_puits :</span>
    <span class="c1">#         Liste_no_sommets_voisins = self.liste_no_sommets_voisins(no_sommet)</span>
    <span class="c1">#         for no_voisin in Liste_no_sommets_voisins:</span>
    <span class="c1">#             voisin = self.liste_sommets[no_voisin]</span>
    <span class="c1">#             self.ajoute_arc(sommet,voisin,img)</span>
    
<div class="viewcode-block" id="Graphe.cree_arcs_de_sommet_vers_voisins"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.cree_arcs_de_sommet_vers_voisins">[docs]</a>    <span class="k">def</span> <span class="nf">cree_arcs_de_sommet_vers_voisins</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">no_sommet</span><span class="p">,</span> <span class="n">img</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Crée tous les arc partant d&#39;un sommet identifié par son no vers tous ses voisins</span>
<span class="sd">        si le sommet n&#39;est pas le puits, chercher les voisins et creer les arcs qui vont su sommet vers ses voisins&quot;&quot;&quot;</span>
        <span class="n">sommet</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">liste_sommets</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">no_sommet</span> <span class="o">!=</span> <span class="bp">self</span><span class="o">.</span><span class="n">no_puits</span> <span class="p">:</span>
            <span class="n">Liste_no_sommets_voisins</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_no_sommets_voisins</span><span class="p">(</span><span class="n">no_sommet</span><span class="p">)</span>
            <span class="c1"># affichage liste voisins</span>
            <span class="c1"># print(no_sommet)</span>
            <span class="c1"># sommet.affiche_sommet()</span>
            <span class="c1"># print()</span>
            <span class="c1"># print(Liste_no_sommets_voisins)</span>
            <span class="k">for</span> <span class="n">no_voisin</span> <span class="ow">in</span> <span class="n">Liste_no_sommets_voisins</span><span class="p">:</span>
                <span class="n">voisin</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_sommets</span><span class="p">[</span><span class="n">no_voisin</span><span class="p">]</span>
                <span class="c1">#affiche debug</span>
                <span class="c1"># voisin.affiche_sommet()</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">ajoute_arc</span><span class="p">(</span><span class="n">sommet</span><span class="p">,</span><span class="n">voisin</span><span class="p">,</span><span class="n">img</span><span class="p">)</span></div>
                
<div class="viewcode-block" id="Graphe.supprime_arcs_vers_sommet"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.supprime_arcs_vers_sommet">[docs]</a>    <span class="k">def</span> <span class="nf">supprime_arcs_vers_sommet</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;supprime tous les arcs arrivant à un sommet repéré par son no_sommet et partant de ses voisins&quot;&quot;&quot;</span>
        <span class="n">sommet</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">liste_sommets</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span>
        <span class="n">Liste_no_sommets_voisins</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_no_sommets_voisins</span><span class="p">(</span><span class="n">no_sommet</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">no_voisin</span> <span class="ow">in</span> <span class="n">Liste_no_sommets_voisins</span><span class="p">:</span>
            <span class="c1"># recopie de l&#39;adresse de la liste puis modification du contenu commun</span>
            <span class="n">Liste_arcs_du_voisin</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_voisin</span><span class="p">]</span> 
            <span class="k">for</span> <span class="n">arc</span> <span class="ow">in</span> <span class="n">Liste_arcs_du_voisin</span> <span class="p">:</span>
                <span class="k">if</span>  <span class="n">sommet</span><span class="o">.</span><span class="n">est_egal</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">destination</span><span class="p">)</span> <span class="p">:</span>
                    <span class="n">Liste_arcs_du_voisin</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">arc</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="Graphe.image_2_liste_arcs"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.image_2_liste_arcs">[docs]</a>    <span class="k">def</span> <span class="nf">image_2_liste_arcs</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">img</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Crée la liste des arcs à partir de l&#39;image </span>
<span class="sd">        La liste des sommets doit être créée au préalable &quot;&quot;&quot;</span>
        <span class="c1">#print(&quot;Création des arcs !&quot;)</span>
        <span class="c1"># initialisation de liste des listes d&#39;arcs partant de chaque sommet</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="o">*</span><span class="p">[</span><span class="kc">None</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">no_sommet</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span><span class="o">=</span><span class="p">[]</span>
        <span class="c1"># Remplissage des listes</span>
        <span class="k">for</span> <span class="n">no_sommet</span> <span class="ow">in</span> <span class="nb">range</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cree_arcs_de_sommet_vers_voisins</span><span class="p">(</span><span class="n">no_sommet</span><span class="p">,</span> <span class="n">img</span><span class="p">)</span>   
        <span class="c1">#print(&quot;Fin de création des arcs !&quot;)</span>
        <span class="c1">#affichage liste des arcs</span>
        <span class="c1"># for i in range(self.nb_sommets):</span>
        <span class="c1">#     print(self.liste_arcs[i])        </span>
        <span class="sd">&quot;&quot;&quot; On supprime les arcs qui arrivent au sommet source et qui ont étés créés inutilement </span>
<span class="sd">        (c&#39;est moins long que de tester si source est le voisin à chaque création d&#39;arc étant donné le nombre</span>
<span class="sd">        de pixels dans une image, le coût de la supression est constant)&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">supprime_arcs_vers_sommet</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">no_source</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="Graphe.arc_de_sommet1_a_sommet2"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.arc_de_sommet1_a_sommet2">[docs]</a>    <span class="k">def</span> <span class="nf">arc_de_sommet1_a_sommet2</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet1</span><span class="p">,</span><span class="n">no_sommet2</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; retourne l&#39;arc qui va du sommet1 au sommet2&quot;&quot;&quot;</span>
        <span class="c1"># affichage debug</span>
        <span class="c1">#print(no_sommet1)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_sommet1</span><span class="p">]</span><span class="o">!=</span><span class="p">[]:</span>
            <span class="k">for</span> <span class="n">arc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_sommet1</span><span class="p">]:</span>
                <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">destination</span><span class="p">)</span><span class="o">==</span><span class="n">no_sommet2</span><span class="p">:</span>
                    <span class="k">return</span><span class="p">(</span><span class="n">arc</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Pas d&#39;arc partant de ce sommet!&quot;</span><span class="p">)</span>
            <span class="k">return</span><span class="p">()</span></div>
            
<div class="viewcode-block" id="Graphe.arc_inverse"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.arc_inverse">[docs]</a>    <span class="k">def</span> <span class="nf">arc_inverse</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">arc</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; retourne l&#39;arc (sommet 2-&gt;sommet 1) inverse de arc (sommet 1-&gt;sommet 2)</span>
<span class="sd">        a ne pas appliquer si arc.destination = sommet d&#39;arrivée ou si arc.origine = sommet de départ puisqu&#39;aucun arc </span>
<span class="sd">        n&#39;arrive au départ ni ne part de l&#39;arrivée &quot;&quot;&quot;</span>
        <span class="n">no_arc_destination</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">destination</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">a</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_arc_destination</span><span class="p">]:</span>
            <span class="k">if</span> <span class="n">a</span><span class="o">.</span><span class="n">destination</span><span class="o">.</span><span class="n">est_egal</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">origine</span><span class="p">):</span>
                <span class="c1"># print()</span>
                <span class="c1"># arc.affiche_arc()</span>
                <span class="c1"># a.affiche_arc()</span>
                <span class="c1"># print()</span>
                <span class="k">return</span> <span class="n">a</span>  </div>
                
<div class="viewcode-block" id="Graphe.supprime_arcs_poids_zero"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.supprime_arcs_poids_zero">[docs]</a>    <span class="k">def</span> <span class="nf">supprime_arcs_poids_zero</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; supprime tous les arcs de poids zéro du graphe de flot&quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">no_sommet</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="p">)</span> <span class="p">:</span>
            <span class="k">for</span> <span class="n">arc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]:</span>
                <span class="k">if</span> <span class="n">arc</span><span class="o">.</span><span class="n">poids</span><span class="o">==</span><span class="mi">0</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">arc</span><span class="p">)</span>   </div>

    <span class="c1">## FONCTIONS POUR LA RECHERCHE DE CHEMIN</span>
    
<div class="viewcode-block" id="Graphe.distances_minimales"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.distances_minimales">[docs]</a>    <span class="k">def</span> <span class="nf">distances_minimales</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet_depart</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; calcule la distance d&#39;un chemin minimal entre le sommet de départ identifié par no_sommet_départ</span>
<span class="sd">        et tous les sommets du graphe. Retourne la liste des distances minimales indexée par les no de sommet correspondant</span>
<span class="sd">        Algorithme de Bellman-Ford avec mémorisation des pères&quot;&quot;&quot;</span>
        <span class="c1"># Création de la liste des distances au sommet de départ</span>
        <span class="n">liste_distance</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="o">*</span><span class="p">[</span><span class="n">math</span><span class="o">.</span><span class="n">inf</span><span class="p">]</span>
        <span class="n">liste_distance</span><span class="p">[</span><span class="n">no_sommet_depart</span><span class="p">]</span><span class="o">=</span><span class="mi">0</span>
        <span class="c1"># Création de la liste des pères par chemin minimal</span>
        <span class="n">liste_peres</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="o">*</span><span class="p">[</span><span class="kc">None</span><span class="p">]</span>
        <span class="c1"># Céation de la liste des numéros de sommets à explorer</span>
        <span class="n">Liste_no_sommets_a_explorer</span><span class="o">=</span><span class="p">[</span><span class="n">no_sommet_depart</span><span class="p">]</span>
        <span class="k">while</span> <span class="n">Liste_no_sommets_a_explorer</span> <span class="o">!=</span> <span class="p">[]:</span>
            <span class="n">no_sommet_a_explorer</span> <span class="o">=</span> <span class="n">Liste_no_sommets_a_explorer</span> <span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="c1">#Liste_no_sommets_voisins = self.liste_no_sommets_voisins(no_sommet_a_explorer)</span>
            <span class="c1">##on a la liste des arcs... donc on connais les voisins...</span>
            <span class="k">for</span> <span class="n">arc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_sommet_a_explorer</span><span class="p">]:</span>
                <span class="n">distance_sommet_a_explorer</span><span class="o">=</span><span class="n">liste_distance</span><span class="p">[</span><span class="n">no_sommet_a_explorer</span><span class="p">]</span>
                <span class="n">no_sommet_voisin</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">destination</span><span class="p">)</span>
                <span class="n">distance_sommet_voisin</span><span class="o">=</span><span class="n">liste_distance</span><span class="p">[</span><span class="n">no_sommet_voisin</span><span class="p">]</span>
                <span class="n">distance_sommet_a_voisin</span> <span class="o">=</span> <span class="n">arc</span><span class="o">.</span><span class="n">poids</span>
                <span class="k">if</span> <span class="n">distance_sommet_voisin</span> <span class="o">&gt;</span> <span class="n">distance_sommet_a_explorer</span> <span class="o">+</span> <span class="n">distance_sommet_a_voisin</span> <span class="p">:</span>
                    <span class="c1"># maj de la liste des distances</span>
                    <span class="n">liste_distance</span><span class="p">[</span><span class="n">no_sommet_voisin</span><span class="p">]</span> <span class="o">=</span> <span class="n">distance_sommet_a_explorer</span> <span class="o">+</span> <span class="n">distance_sommet_a_voisin</span>
                    <span class="c1"># maj de la liste des sommets à explorer</span>
                    <span class="n">Liste_no_sommets_a_explorer</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">no_sommet_voisin</span><span class="p">)</span>
                    <span class="c1"># maj de la liste des peres</span>
                    <span class="n">liste_peres</span><span class="p">[</span><span class="n">no_sommet_voisin</span><span class="p">]</span><span class="o">=</span><span class="n">no_sommet_a_explorer</span>
            <span class="n">Liste_no_sommets_a_explorer</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">no_sommet_a_explorer</span><span class="p">)</span>
        <span class="k">return</span> <span class="p">[</span><span class="n">liste_distance</span><span class="p">,</span> <span class="n">liste_peres</span> <span class="p">]</span> </div>
    
<div class="viewcode-block" id="Graphe.cherche_chemin_minimal"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.cherche_chemin_minimal">[docs]</a>    <span class="k">def</span> <span class="nf">cherche_chemin_minimal</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet_depart</span><span class="p">,</span><span class="n">no_sommet_arrivee</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Retourne la liste des sommets formant un chemin minimal du sommet de no_sommet_depart au sommet de  no_sommet_arrivee &quot;&quot;&quot;</span>
        <span class="n">Liste_distance</span><span class="p">,</span><span class="n">Liste_peres</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">distances_minimales</span><span class="p">(</span><span class="n">no_sommet_depart</span><span class="p">)</span>
        <span class="n">chemin</span><span class="o">=</span><span class="p">[]</span>
        <span class="n">no_sommet</span><span class="o">=</span><span class="n">no_sommet_arrivee</span>
        <span class="k">while</span> <span class="n">no_sommet</span><span class="o">!=</span><span class="n">no_sommet_depart</span><span class="p">:</span>
            <span class="n">chemin</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">no_sommet</span><span class="p">)</span>
            <span class="n">no_sommet</span><span class="o">=</span><span class="n">Liste_peres</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span>
        <span class="n">chemin</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">no_sommet</span><span class="p">)</span>
        <span class="k">return</span><span class="p">(</span><span class="n">chemin</span><span class="p">)</span></div>
            
    <span class="c1"># def cherche_chemin_minimal(self,no_sommet_depart,no_sommet_arrivee):</span>
    <span class="c1">#     Liste_distance=self.distances_minimales(no_sommet_depart)</span>
    <span class="c1">#     Liste_sommets=[]</span>
    <span class="c1">#     S=no_sommet_arrivee</span>
    <span class="c1">#     while S!=no_sommet_depart:</span>
    <span class="c1">#         for T in liste des peres de S</span>
    <span class="c1">#             if Liste_distance[S]=Liste_distance[T]+d(s,T):</span>
    <span class="c1">#                 Liste_sommets.append(T)</span>
    <span class="c1">#                 break</span>
    <span class="c1">#         S=T</span>
        
<div class="viewcode-block" id="Graphe.distances_maximales"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.distances_maximales">[docs]</a>    <span class="k">def</span> <span class="nf">distances_maximales</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet_depart</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; calcule la pseudo-distance minimale (somme des inverses des poids des arêtes) d&#39;un chemin maximal non infini</span>
<span class="sd">         entre le sommet de départ identifié par no_sommet_départ et tous les sommets du graphe. </span>
<span class="sd">         Retourne la liste des pseudo distances minimales indexée par les no de sommet correspondant</span>
<span class="sd">         Algorithme de Bellman-Ford avec mémorisation des pères&quot;&quot;&quot;</span>
        <span class="c1"># Création de la liste des distances au sommet de départ</span>
        <span class="n">liste_distance</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="o">*</span><span class="p">[</span><span class="n">math</span><span class="o">.</span><span class="n">inf</span><span class="p">]</span>
        <span class="n">liste_distance</span><span class="p">[</span><span class="n">no_sommet_depart</span><span class="p">]</span><span class="o">=</span><span class="mi">0</span>
        <span class="c1"># Création de la liste des pères par chemin minimal</span>
        <span class="n">liste_peres</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="o">*</span><span class="p">[</span><span class="kc">None</span><span class="p">]</span>
        <span class="c1"># Céation de la liste des numéros de sommets à explorer</span>
        <span class="n">Liste_no_sommets_a_explorer</span><span class="o">=</span><span class="p">[</span><span class="n">no_sommet_depart</span><span class="p">]</span>
        <span class="k">while</span> <span class="n">Liste_no_sommets_a_explorer</span> <span class="o">!=</span> <span class="p">[]:</span>
            <span class="n">no_sommet_a_explorer</span> <span class="o">=</span> <span class="n">Liste_no_sommets_a_explorer</span> <span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="c1">#Liste_no_sommets_voisins = self.liste_no_sommets_voisins(no_sommet_a_explorer)</span>
            <span class="c1">##on a la liste des arcs... donc on connais les voisins...</span>
            <span class="k">for</span> <span class="n">arc</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_arcs</span><span class="p">[</span><span class="n">no_sommet_a_explorer</span><span class="p">]:</span>
                <span class="n">distance_sommet_a_explorer</span><span class="o">=</span><span class="n">liste_distance</span><span class="p">[</span><span class="n">no_sommet_a_explorer</span><span class="p">]</span>
                <span class="n">no_sommet_voisin</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">destination</span><span class="p">)</span>
                <span class="n">distance_sommet_voisin</span><span class="o">=</span><span class="n">liste_distance</span><span class="p">[</span><span class="n">no_sommet_voisin</span><span class="p">]</span>
                <span class="n">distance_sommet_a_voisin</span> <span class="o">=</span> <span class="n">arc</span><span class="o">.</span><span class="n">inverse_poids</span><span class="p">()</span>  <span class="c1"># ici les poids des arcs sont remplacés par leurs inverses</span>
                <span class="k">if</span> <span class="n">distance_sommet_voisin</span> <span class="o">&gt;</span> <span class="n">distance_sommet_a_explorer</span> <span class="o">+</span> <span class="n">distance_sommet_a_voisin</span> <span class="p">:</span>
                    <span class="c1"># maj de la liste des distances</span>
                    <span class="n">liste_distance</span><span class="p">[</span><span class="n">no_sommet_voisin</span><span class="p">]</span> <span class="o">=</span> <span class="n">distance_sommet_a_explorer</span> <span class="o">+</span> <span class="n">distance_sommet_a_voisin</span>
                    <span class="c1"># maj de la liste des sommets à explorer</span>
                    <span class="n">Liste_no_sommets_a_explorer</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">no_sommet_voisin</span><span class="p">)</span>
                    <span class="c1"># maj de la liste des peres</span>
                    <span class="n">liste_peres</span><span class="p">[</span><span class="n">no_sommet_voisin</span><span class="p">]</span><span class="o">=</span><span class="n">no_sommet_a_explorer</span>
            <span class="n">Liste_no_sommets_a_explorer</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">no_sommet_a_explorer</span><span class="p">)</span>
            <span class="c1">#print(liste_peres)</span>
            <span class="c1">#print(liste_distance)</span>
        <span class="k">return</span> <span class="n">liste_distance</span><span class="p">,</span><span class="n">liste_peres</span>  </div>
    
<div class="viewcode-block" id="Graphe.cherche_chemin_maximal_sommets"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.cherche_chemin_maximal_sommets">[docs]</a>    <span class="k">def</span> <span class="nf">cherche_chemin_maximal_sommets</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet_depart</span><span class="p">,</span><span class="n">no_sommet_arrivee</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Retourne la liste des sommets formant un chemin maximal non infini du sommet de no_sommet_depart au sommet de  no_sommet_arrivee &quot;&quot;&quot;</span>
        <span class="n">Liste_distance</span><span class="p">,</span><span class="n">Liste_peres</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">distances_maximales</span><span class="p">(</span><span class="n">no_sommet_depart</span><span class="p">)</span>
        <span class="n">chemin</span><span class="o">=</span><span class="p">[]</span>
        <span class="n">no_sommet</span><span class="o">=</span><span class="n">no_sommet_arrivee</span>
        <span class="k">while</span> <span class="n">no_sommet</span><span class="o">!=</span><span class="n">no_sommet_depart</span><span class="p">:</span>
            <span class="n">chemin</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">no_sommet</span><span class="p">)</span>
            <span class="n">no_sommet</span><span class="o">=</span><span class="n">Liste_peres</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span>
        <span class="n">chemin</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">no_sommet</span><span class="p">)</span>
        <span class="k">return</span><span class="p">(</span><span class="n">chemin</span><span class="p">)</span></div>
    
<div class="viewcode-block" id="Graphe.cherche_chemin_maximal_arcs"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.cherche_chemin_maximal_arcs">[docs]</a>    <span class="k">def</span> <span class="nf">cherche_chemin_maximal_arcs</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet_depart</span><span class="p">,</span><span class="n">no_sommet_arrivee</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Retourne la liste des arcs formant un chemin maximal non infini du sommet de no_sommet_depart au sommet de  no_sommet_arrivee &quot;&quot;&quot;</span>
        <span class="c1"># print(&quot;recherche chemin max arc&quot;)</span>
        <span class="c1"># print(no_sommet_depart)</span>
        <span class="c1"># print(no_sommet_arrivee)</span>
        <span class="n">Liste_distance</span><span class="p">,</span><span class="n">Liste_peres</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">distances_maximales</span><span class="p">(</span><span class="n">no_sommet_depart</span><span class="p">)</span>
        <span class="n">chemin</span><span class="o">=</span><span class="p">[]</span>
        <span class="n">no_sommet</span><span class="o">=</span><span class="n">no_sommet_arrivee</span>
        <span class="k">while</span> <span class="n">no_sommet</span><span class="o">!=</span><span class="n">no_sommet_depart</span> <span class="ow">and</span> <span class="n">no_sommet</span><span class="o">!=</span><span class="kc">None</span><span class="p">:</span>
            <span class="c1">#print(&quot;no sommet = %d&quot;%no_sommet)</span>
            <span class="n">no_pere</span><span class="o">=</span><span class="n">Liste_peres</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span>
            <span class="c1">#print(no_pere)</span>
            <span class="k">if</span> <span class="n">no_pere</span><span class="o">!=</span><span class="kc">None</span><span class="p">:</span>
                <span class="n">arc</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">arc_de_sommet1_a_sommet2</span><span class="p">(</span><span class="n">no_pere</span><span class="p">,</span><span class="n">no_sommet</span><span class="p">)</span>
                <span class="n">chemin</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="n">arc</span><span class="p">)</span>
            <span class="n">no_sommet</span><span class="o">=</span><span class="n">no_pere</span>
            
        <span class="c1"># affichage debug</span>
        <span class="c1">#print(&quot;chemin : &quot;,chemin)</span>
        <span class="c1">#print(&quot;liste peres : &quot;, Liste_peres)</span>
        <span class="c1">#print(&quot;longueur liste peres : &quot;, len(Liste_peres))</span>
        <span class="k">return</span><span class="p">(</span><span class="n">chemin</span><span class="p">)</span></div>
        
    <span class="c1"># def cherche_chemin_maximal(self,no_sommet_depart,no_sommet_arrivee):</span>
    <span class="c1">#     Liste_distance=self.distances_maximales(no_sommet_depart)</span>
    <span class="c1">#     Liste_sommets=[]</span>
    
    <span class="c1">## FONCTIONS POUR L&#39;ALGORITHME DE GRAPH CUT</span>
<div class="viewcode-block" id="Graphe.poids_min_dans_chemin"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.poids_min_dans_chemin">[docs]</a>    <span class="k">def</span> <span class="nf">poids_min_dans_chemin</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">chemin</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Retourne le poids minimal des arcs contenus dans chemin formé d&#39;une liste d&#39;arcs &quot;&quot;&quot;</span>
        <span class="nb">min</span><span class="o">=</span><span class="n">math</span><span class="o">.</span><span class="n">inf</span>
        <span class="k">for</span> <span class="n">arc</span> <span class="ow">in</span> <span class="n">chemin</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">arc</span><span class="o">.</span><span class="n">poids</span><span class="o">&lt;</span><span class="nb">min</span><span class="p">:</span>
                <span class="nb">min</span><span class="o">=</span><span class="n">arc</span><span class="o">.</span><span class="n">poids</span>
        <span class="k">return</span> <span class="nb">min</span></div>
        
<div class="viewcode-block" id="Graphe.ford_fulkerson"><a class="viewcode-back" href="../tec_doc.html#Graphe.Graphe.ford_fulkerson">[docs]</a>    <span class="k">def</span> <span class="nf">ford_fulkerson</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">no_sommet_depart</span><span class="p">,</span><span class="n">no_sommet_arrivee</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; </span>
<span class="sd">        Algorithme de Ford-Fulkerson &quot;&quot;&quot;</span>
        <span class="n">chemin</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">cherche_chemin_maximal_arcs</span><span class="p">(</span><span class="n">no_sommet_depart</span><span class="p">,</span><span class="n">no_sommet_arrivee</span><span class="p">)</span>
        <span class="c1">#i=0</span>
        <span class="k">while</span> <span class="n">chemin</span><span class="o">!=</span><span class="p">[]:</span>
            <span class="c1">#affichage debug</span>
            <span class="c1">#print(i)</span>
            <span class="n">m</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">poids_min_dans_chemin</span><span class="p">(</span><span class="n">chemin</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">arc</span> <span class="ow">in</span> <span class="n">chemin</span><span class="p">:</span>
                <span class="n">no_arc_origine</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">origine</span><span class="p">)</span>
                <span class="n">no_arc_destination</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">sommet_2_no_sommet</span><span class="p">(</span><span class="n">arc</span><span class="o">.</span><span class="n">destination</span><span class="p">)</span>
                <span class="n">arc</span><span class="o">.</span><span class="n">poids</span><span class="o">-=</span><span class="n">m</span>
                <span class="k">if</span> <span class="ow">not</span> <span class="p">(</span><span class="n">no_arc_origine</span><span class="o">==</span><span class="n">no_sommet_depart</span> <span class="ow">or</span> <span class="n">no_arc_destination</span><span class="o">==</span><span class="n">no_sommet_arrivee</span><span class="p">):</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">arc_inverse</span><span class="p">(</span><span class="n">arc</span><span class="p">)</span><span class="o">.</span><span class="n">poids</span><span class="o">+=</span><span class="n">m</span>
            <span class="n">chemin</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">cherche_chemin_maximal_arcs</span><span class="p">(</span><span class="n">no_sommet_depart</span><span class="p">,</span><span class="n">no_sommet_arrivee</span><span class="p">)</span></div>
            <span class="c1">#i+=1</span>
    
    <span class="k">def</span> <span class="nf">liste_no_sommets_atteignables_from_liste_distances</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">liste_distances</span><span class="p">):</span>
        <span class="n">liste_no_sommets_atteignables</span><span class="o">=</span><span class="p">[]</span>
        <span class="k">for</span> <span class="n">no_sommet</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_sommets</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">liste_distances</span><span class="p">[</span><span class="n">no_sommet</span><span class="p">]</span><span class="o">&lt;</span><span class="n">math</span><span class="o">.</span><span class="n">inf</span><span class="p">:</span>
                <span class="n">liste_no_sommets_atteignables</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">no_sommet</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">liste_no_sommets_atteignables</span>
        
    <span class="k">def</span> <span class="nf">liste_no_sommets_2_liste_coordonnees</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">liste_no_sommets</span><span class="p">):</span>
        <span class="n">liste_sommets</span><span class="o">=</span><span class="p">[]</span>
        <span class="k">for</span> <span class="n">no_sommet</span> <span class="ow">in</span> <span class="n">liste_no_sommets</span><span class="p">:</span>
            <span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">no_sommet_2_coordonnees</span><span class="p">(</span><span class="n">no_sommet</span><span class="p">)</span>
            <span class="n">liste_sommets</span><span class="o">.</span><span class="n">append</span><span class="p">([</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">liste_sommets</span>    

    <span class="k">def</span> <span class="nf">graph_cut</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">ford_fulkerson</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">no_source</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">no_puits</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">supprime_arcs_poids_zero</span><span class="p">()</span>
        <span class="n">liste_distance</span><span class="p">,</span><span class="n">Liste_peres</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">distances_minimales</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">no_source</span><span class="p">)</span>
        <span class="c1">#print(liste_distance)</span>
        <span class="n">liste_no_sommets_atteignables</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">liste_no_sommets_atteignables_from_liste_distances</span><span class="p">(</span><span class="n">liste_distance</span><span class="p">)</span>
        <span class="n">liste_sommets_atteignables</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">liste_no_sommets_2_liste_coordonnees</span><span class="p">(</span><span class="n">liste_no_sommets_atteignables</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">liste_sommets_atteignables</span>       </div>
    
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" >Code du module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, Cecile Prouteau.
      Créé avec <a href="http://sphinx-doc.org/">Sphinx</a> 1.7.9.
    </div>
  </body>
</html>